var AbstractTEA = function () {
  	this.formatKey =function(key) {
        var formattedKey = strToInt(key);

        if (formattedKey.length > 4) {
			throw "Key cannot be greater than 128-bit in length!";
		}
        else if (formattedKey.length < 4) {
			for (var i = formattedKey.length; i < 4; i++) {
                formattedKey[i] = 0;
           	}
        }
        
        return formattedKey;
 	};

	this.encryptString = function (num_rounds, str, key) {
	   	str = addPadding(str, 8, str.length);
        var formattedKey = this.formatKey(key);
	    var dataBytes = strToInt(str);

	    var cipher = "";
	    var tempData = [];
	    for(var i=0; i < dataBytes.length; i+=2)
	    {
	        tempData[0] = dataBytes[i];
	        tempData[1] = dataBytes[i+1];
	        this.encipher(num_rounds, tempData, formattedKey);
            cipher += littleEndianArrayToHex(tempData);
	    }

	    return cipher;
	};

	this.decryptString = function (num_rounds, cipher, key) {
        var formattedKey = this.formatKey(key);
	    var dataBytes = strToInt(hexToStr(cipher));
	    
	    var plain = "";
	    var tempData = [];
	    for(var i=0; i < dataBytes.length; i+=2)
	    {
	        tempData[0] = dataBytes[i];
	        tempData[1] = dataBytes[i+1];
	        this.decipher(num_rounds, tempData, formattedKey);
            plain += intToStr(tempData);
	    }

	    return plain;
	};
};
